#version 330 core

//------------------------------------------------
//  TESSELLATION CONTROL SHADER (TCS)
//  C EST LE DEUXIEME PROGRAMME EXECUTE SUR LA CARTE GRAPHIQUE
//------------------------------------------------

// CE TCS RESSORT LES 25 SOMMETS D UN PATCH DE BEZIER QUARTIQUE
// AINSI QU'IMPLICITEMENT LES DEUX COORDONNEES DE TESSELLATION
layout(vertices = 4) out;


// LE PROGRAMME CPU TRANSMET UN FLOTTANT A CE TCS QUI NOUS SERT A FAIRE VARIER DYNAMIQUEMENT LE NIVEAU DE TESSELLATION
uniform float u_FinesseDecoupage;

void main(void)
{
// LE NOMBRE DE SOMMET DEFINSSANT LE PATCH VAUT 25 DANS CET EXEMPLE
// CE NOMBRE EST CONTENU DANS LA VARIABLE gl_PatchVerticesIn

// NIVEAU DE TESSELLATION DES 4 ARETES DU PATCH
	gl_TessLevelOuter[0] = 4;
	gl_TessLevelOuter[1] = u_FinesseDecoupage;
	gl_TessLevelOuter[2] = 4;
	gl_TessLevelOuter[3] = u_FinesseDecoupage;

// NIVEAU DE TESSELLATION DE L INTERIEUR DU PATCH DANS LES DEUX DIRECTIONS PARAMETRIQUES
	gl_TessLevelInner[0] = u_FinesseDecoupage;
	gl_TessLevelInner[1] = 4;

// g_InvocationID indique la cle de l unique sommet produit par l appel courant a ce TCS (Tesselation Control Shader)
// Ici on se contente de recopier en sortie la position donnee en entree

	gl_out[gl_InvocationID].gl_Position = gl_in[gl_InvocationID].gl_Position;
}
