#version 330 core

//----------------------------------------------
// FRAGMENT SHADER
// C EST LE QUATRIEME ET DERNIER PROGRAMME EXECUTE PAR LA CARTE GRAPHIQUE
//----------------------------------------------

// EN SORTIE ON CALCULE UNE COULEUR A 4 COORDONNEES 
layout(location = 0, index = 0) out vec4 fragColor;

// EN ENTREE ON DISPOSE DES DEUX DERIVEES PARAMETRIQUES DANS L ESPACE OBJET
in vec4 OutPU, OutPV;

in float EcartPourInterpolation;
in float TessXInt, TessYInt;

uniform float MonTemps;
uniform float MaForceTotale;

vec4 CouleurFond;
vec4 CouleurRepos;
vec4 CouleurMax;
float AmplitudeRespiration;

void main(void)
{
//	fragColor = gl_FragCoord;
//	fragColor = vec4(1.0,0.6,0.6,1.);
//	fragColor = mix(vec4(1.0,0.6,0.6,1.), vec4(0.,0.,1.,1.), TessXInt);
	float AmplitudeRespiration;
	const float FrequenceRespiration = 10.;

	CouleurFond = vec4( 0.2, 0.2, 0.2, 1.);

	CouleurMax = mix(vec4(1.0,0.6,0.6,1.), vec4(0.,0.,0.,1.), abs(EcartPourInterpolation)); // OMBRAGE TUBULAIRE

	CouleurRepos = mix( CouleurFond, CouleurMax, 0.5);

	AmplitudeRespiration = MaForceTotale/30.;

	float MelangeRespiration =  (1.+sin(MonTemps+TessXInt*FrequenceRespiration))*AmplitudeRespiration;

	fragColor = mix(CouleurRepos, CouleurMax, MelangeRespiration); // RESPIRATION
}
